// TsPacketParser.h: CTsPacketParser NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSPACKETPARSER_H_)
#define _TSPACKETPARSER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IMediaDecoder.h"
#include "TsStream.h"


/////////////////////////////////////////////////////////////////////////////
// TSpPbgofR[_(oCif[^TSpPbg𒊏o)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData	TSpPbg܂ރoCif[^
// Output	#0	: CTsPacket		TSpPbg
/////////////////////////////////////////////////////////////////////////////

class CTsPacketParser : public IMediaDecoder  
{
public:
	CTsPacketParser();
	virtual ~CTsPacketParser();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0);

// CTsPacketParser
	const DWORD GetErrorPacketCount(void) const;
	const DWORD GetValidPacketCount(void) const;

private:
	void SyncPacket(const BYTE *pData, const DWORD dwSize);
	void ParsePacket(void);

	CTsPacket *m_pOutputPacket;

	DWORD m_dwErrorPacketCount;
	DWORD m_dwValidPacketCount;
	BYTE m_abyContCounter[0x1FFF];
};

#endif // !defined(_TSPACKETPARSER_H_)
